function Initialize()
	COUNTER = 60 
	PREVSTATE = -1
	CURRTRACK = ""
	POS = 0
	DUR = 0
	--PREV = 0
	NEXT = 0
	PAUSE = 0
	PLAY = 0
	STOP = 0
end

function Update()

  --[[	GET STATE	]]
  STATE = (SKIN:GetMeasure("MeasurePlayerState")):GetValue()
  --[[	GET TRACK	]]
  TRACK = (SKIN:GetMeasure("TRACK")):GetStringValue()  
	
  --[[	DETECT A CHANGE	]]
  if STATE ~= PREVSTATE or TRACK ~= CURRTRACK then
	COUNTER = 0 --RESET
  end
  
  --[[	DETECT WHICH CHANGE	]]
  if STATE == 0 and PAUSE == 0 and PLAY == 0 and NEXT == 0 and STOP == 0 then
    --;
    NEXT = 0
	PLAY = 0
	STOP = 0
    PAUSE = 0
  elseif NEXT == 1 and STATE == 0 and COUNTER > 1 then --PAUSE FROM NEXT @ STOP
	PAUSE = 1
	NEXT = 0
	PLAY = 0
	STOP = 0
  elseif PLAY == 1 and STATE == 0 and COUNTER > 2 then --PAUSE FROM NEXT @ STOP AFTER PLAY
	PAUSE = 1
	NEXT = 0
	PLAY = 0
	STOP = 0
  elseif STATE == 1 and (PAUSE == 1 or STOP == 1) and COUNTER > 1 then	--PLAY
    PLAY = 1
	NEXT = 0
	PAUSE = 0
	STOP = 0
  elseif STATE == 2 then -- PAUSE
    PAUSE = 1
	PLAY = 0
	NEXT = 0
	STOP = 0
  elseif TRACK ~= CURRTRACK and POS < DUR - 1 then --NEXT (SWITCH SONG BEFORE IT'S OVER)
    NEXT = 1
	PLAY = 0
	PAUSE = 0
	STOP = 0
  elseif TRACK ~= CURRTRACK then  --else  
    NEXT = 0
	PAUSE = 0
	PLAY = 0
	STOP = 0
  end
  
  --[[	GET DURATION	]]
  DUR = (SKIN:GetMeasure("DURATION")):GetValue()
  --[[	GET POSITION	]]
  POS = (SKIN:GetMeasure("POSITION")):GetValue()
  
  CURRTRACK = TRACK --SET CURRTRACK TO CURRENT TRACK - !AFTER! CHECKS
  
  --[[	DISPLAY FOR ~2 SECONDS AFTER LAST ACTION	]]
  if COUNTER < 20 then
  
	--[[	-----	STATUS	-----	]]	
	--[[
	if PREV == 1 then -- PREV
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter ALBUMART")
	  SKIN:Bang("!ShowMeter COVERART")
	  SKIN:Bang("!HideMeter PAUSE")
	  SKIN:Bang("!HideMeter PLAY")
	  SKIN:Bang("!HideMeter NEXT")
	  SKIN:Bang("!ShowMeter PREV")
	  SKIN:Bang("!ShowMeter TEXT1")
	  SKIN:Bang("!ShowMeter TEXT2")
	  SKIN:Bang("!ShowMeter TEXT3")
	else
	--]]
	if NEXT == 1 then -- NEXT
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter ALBUMART")
	  SKIN:Bang("!ShowMeter COVERART")
	  SKIN:Bang("!HideMeter PAUSE")
	  SKIN:Bang("!HideMeter PLAY")
	  SKIN:Bang("!ShowMeter NEXT")
	  SKIN:Bang("!HideMeter STOP")
	  --SKIN:Bang("!HideMeter PREV")
	  SKIN:Bang("!ShowMeter TEXT1")
	  SKIN:Bang("!ShowMeter TEXT2")
	  SKIN:Bang("!ShowMeter TEXT3")
	elseif STOP == 1 then -- STOP
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter ALBUMART")
	  SKIN:Bang("!ShowMeter COVERART")
	  SKIN:Bang("!HideMeter PAUSE")
	  SKIN:Bang("!HideMeter PLAY")
	  SKIN:Bang("!HideMeter NEXT")
	  SKIN:Bang("!ShowMeter STOP")
	  --SKIN:Bang("!HideMeter PREV")
	  SKIN:Bang("!ShowMeter TEXT1")
	  SKIN:Bang("!ShowMeter TEXT2")
	  SKIN:Bang("!ShowMeter TEXT3")
	elseif PAUSE == 1 then -- PAUSE
      SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter ALBUMART")
	  SKIN:Bang("!ShowMeter COVERART")
	  SKIN:Bang("!ShowMeter PAUSE")
	  SKIN:Bang("!HideMeter PLAY")
	  SKIN:Bang("!HideMeter NEXT")
	  SKIN:Bang("!HideMeter STOP")
	  --SKIN:Bang("!HideMeter PREV")
	  SKIN:Bang("!ShowMeter TEXT1")
	  SKIN:Bang("!ShowMeter TEXT2")
	  SKIN:Bang("!ShowMeter TEXT3")
	elseif PLAY == 1 then -- PLAY
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter ALBUMART")
	  SKIN:Bang("!ShowMeter COVERART")
	  SKIN:Bang("!HideMeter PAUSE")
	  SKIN:Bang("!ShowMeter PLAY")
	  SKIN:Bang("!HideMeter NEXT")
	  SKIN:Bang("!HideMeter STOP")
	  --SKIN:Bang("!HideMeter PREV")
	  SKIN:Bang("!ShowMeter TEXT1")
	  SKIN:Bang("!ShowMeter TEXT2")
	  SKIN:Bang("!ShowMeter TEXT3")
	else
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter ALBUMART")
	  SKIN:Bang("!ShowMeter COVERART")
	  SKIN:Bang("!HideMeter PAUSE")
	  SKIN:Bang("!HideMeter PLAY")
	  SKIN:Bang("!HideMeter NEXT")
	  SKIN:Bang("!HideMeter STOP")
	  --SKIN:Bang("!HideMeter PREV")
	  SKIN:Bang("!ShowMeter TEXT1")
	  SKIN:Bang("!ShowMeter TEXT2")
	  SKIN:Bang("!ShowMeter TEXT3")
	end
	COUNTER = COUNTER + 1 --UPDATE COUNTER
	PREVSTATE = STATE
  else
    --[[	HIDE EVERYTHING	AFTER TIME IS UP	]]
    SKIN:Bang("!HideMeterGroup 1")
  end
  
  SKIN:Bang("!Redraw")
end