function Initialize()
	COUNTER = 0 --ESSENTIALLY A TIMER
	PREVVOL = 0 --PREVIOUS VOLUME (LAST UPDATE)
	VOLUME  = 0 --CURRENT VOLUME (CURRENT UPDATE)
end

function Update()
 
  --[[	GET VOLUME	]]
  VOLUME = SKIN:GetMeasure("MeasureAudio")
  VOLUME = VOLUME:GetValue()
  
  --[[	DISPLAY FOR ~600 MILISECONDS AFTER LAST ACTION	]]
  if COUNTER < 60 then
  
	--[[	-----	STATUS	-----	]]
	
	--[[	UNMUTE	]]
	if VOLUME > 0 and PREVVOL == -1 then
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!HideMeter VOLDOWN")
	  SKIN:Bang("!HideMeter VOLUP")
	  SKIN:Bang("!ShowMeter UNMUTE")
	  SKIN:Bang("!HideMeter MUTE")
	  SKIN:Bang("!ShowMeter VOLTEXT")
	  SKIN:Bang("!HideMeter meter1")
	  SKIN:Bang("!HideMeter meter2")
	  SKIN:Bang("!HideMeter empty")
	  SKIN:Bang('!SetOption VOLTEXT Text "Unmute')
	--[[	MUTE	]]
	elseif VOLUME == -1 then
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!HideMeter VOLDOWN")
	  SKIN:Bang("!HideMeter VOLUP")
	  SKIN:Bang("!ShowMeter MUTE")
	  SKIN:Bang("!HideMeter UNMUTE")
	  SKIN:Bang("!ShowMeter VOLTEXT")
	  SKIN:Bang("!HideMeter meter1")
	  SKIN:Bang("!HideMeter meter2")
	  SKIN:Bang("!HideMeter empty")
	  SKIN:Bang('!SetOption VOLTEXT Text "Mute"')
	--[[	VOLUME UP	]]
	elseif VOLUME > PREVVOL then
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter VOLTEXT")
	  SKIN:Bang("!ShowMeter VOLUP")
	  SKIN:Bang("!HideMeter VOLDOWN")
	  SKIN:Bang("!HideMeter MUTE")
	  SKIN:Bang("!HideMeter UNMUTE")
	  SKIN:Bang('!SetOption VOLTEXT Text "Volume +"')
	  --[[	VOLUME METER	]]
	  SKIN:Bang("!ShowMeter empty")
	  SKIN:Bang("!ShowMeter meter1")
	  if VOLUME > 3 and VOLUME < 99 then --IF NOT AT BEGINNING OR END, SHOW CAP
	    SKIN:Bang("!ShowMeter meter2")
	  else
	    SKIN:Bang("!HideMeter meter2")
	  end
	--[[	VOLUME DOWN	]]
	elseif VOLUME < PREVVOL then
	  SKIN:Bang("!ShowMeter bg")
	  SKIN:Bang("!ShowMeter VOLDOWN")
	  SKIN:Bang("!HideMeter VOLUP")
	  SKIN:Bang("!ShowMeter VOLTEXT")
	  SKIN:Bang("!HideMeter MUTE")
	  SKIN:Bang("!HideMeter UNMUTE")
	  SKIN:Bang('!SetOption VOLTEXT Text "Volume -"')
	  --[[	VOLUME METER	]]
	  SKIN:Bang("!ShowMeter empty")
	  SKIN:Bang("!ShowMeter meter1")
	  if VOLUME > 3 and VOLUME < 99 then --IF NOT AT BEGINNING OR END, SHOW CAP
	    SKIN:Bang("!ShowMeter meter2")
	  else
	    SKIN:Bang("!HideMeter meter2")
	  end
	end
	
	COUNTER = COUNTER + 1 --UPDATE COUNTER
	PREVVOL = VOLUME --SET PREV VOLUME TO CURRENT VOLUME
  else
    --[[	HIDE EVERYTHING	AFTER TIME IS UP	]]
    SKIN:Bang("!HideMeterGroup Vol")
  end
  SKIN:Bang("!Redraw")
end